#### LOAD config_file
args = commandArgs(TRUE)
if (length(args) > 0) {
  configFile_path <- args[1]
} else {
  cat("\n***WARNING: no ConfigFile was provided. Using default ConfigFile.\n")
}
config <- yaml::yaml.load_file(configFile_path)
file <- config$file
nparams <- config$nparams
sim_data <- config$sim_data
image_folder <- config$image_folder
n_outputs <- config$n_outputs

#### Load data
data_to_train    <- readRDS(paste0(sim_data,"data_to_train.RDS"))
data_to_validate <- readRDS(paste0(sim_data,"data_to_validate.RDS"))

n_dim <- ncol(data_to_train) - nparams # ouput dimenions
#### compute PCA
#mypca         <- prcomp(data_to_train[,1:n_dim], center = TRUE,scale. = TRUE) # Assuming n_dim firsts columns are the output array
mypca         <- prcomp(log(data_to_train[,1:n_dim]), center = TRUE,scale. = TRUE) # Assuming n_dim firsts columns are the output array
reduced_train <- cbind(mypca$x[,1:n_outputs],data_to_train[,(n_dim+1):ncol(data_to_train)])

#### Print/plot pca statistics
print(summary(mypca)$importance[,1:85])

pdf(file = paste0(image_folder,"PC_variance.pdf"), width = 10, height = 6)
plot(mypca,type='l')
dev.off()

#### save data
saveRDS(reduced_train,  file = paste0(sim_data,"reduced_train.RDS"))
saveRDS(mypca,  file = paste0(sim_data,"mypca.RDS"))
